/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef JSDOMWindow_H
#define JSDOMWindow_H

#include "kjs_window.h"


namespace WebCore {

class DOMWindow;

class JSDOMWindow : public KJS::Window {
public:
    JSDOMWindow(DOMWindow*);
    virtual bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    KJS::JSValue* getValueProperty(KJS::ExecState*, int token) const;
    bool customGetOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    virtual void put(KJS::ExecState*, const KJS::Identifier&, KJS::JSValue*, int attr = KJS::None);
    void putValueProperty(KJS::ExecState*, int, KJS::JSValue*, int attr);
    bool customPut(KJS::ExecState*, const KJS::Identifier&, KJS::JSValue*, int attr);
    virtual const KJS::ClassInfo* classInfo() const { return &info; }
    static const KJS::ClassInfo info;

    enum {
        // Attributes
        ScreenAttrNum, HistoryAttrNum, LocationbarAttrNum, MenubarAttrNum, 
        PersonalbarAttrNum, ScrollbarsAttrNum, StatusbarAttrNum, ToolbarAttrNum, 
        NavigatorAttrNum, ClientInformationAttrNum, FrameElementAttrNum, OffscreenBufferingAttrNum, 
        OuterHeightAttrNum, OuterWidthAttrNum, InnerHeightAttrNum, InnerWidthAttrNum, 
        ScreenXAttrNum, ScreenYAttrNum, ScreenLeftAttrNum, ScreenTopAttrNum, 
        ScrollXAttrNum, ScrollYAttrNum, PageXOffsetAttrNum, PageYOffsetAttrNum, 
        ClosedAttrNum, LengthAttrNum, NameAttrNum, StatusAttrNum, 
        DefaultStatusAttrNum, DefaultstatusAttrNum, SelfAttrNum, WindowAttrNum, 
        FramesAttrNum, OpenerAttrNum, ParentAttrNum, TopAttrNum, 
        DocumentAttrNum, DevicePixelRatioAttrNum, StyleSheetConstructorAttrNum, CSSStyleSheetConstructorAttrNum, 
        CSSValueConstructorAttrNum, CSSPrimitiveValueConstructorAttrNum, CSSValueListConstructorAttrNum, CSSRuleConstructorAttrNum, 
        CSSCharsetRuleConstructorAttrNum, CSSFontFaceRuleConstructorAttrNum, CSSImportRuleConstructorAttrNum, CSSMediaRuleConstructorAttrNum, 
        CSSPageRuleConstructorAttrNum, CSSStyleRuleConstructorAttrNum, CSSStyleDeclarationConstructorAttrNum, MediaListConstructorAttrNum, 
        CounterConstructorAttrNum, CSSRuleListConstructorAttrNum, RectConstructorAttrNum, DOMImplementationConstructorAttrNum, 
        DocumentFragmentConstructorAttrNum, DocumentConstructorAttrNum, NodeConstructorAttrNum, NodeListConstructorAttrNum, 
        NamedNodeMapConstructorAttrNum, CharacterDataConstructorAttrNum, AttrConstructorAttrNum, ElementConstructorAttrNum, 
        TextConstructorAttrNum, CommentConstructorAttrNum, CDATASectionConstructorAttrNum, DocumentTypeConstructorAttrNum, 
        NotationConstructorAttrNum, EntityConstructorAttrNum, EntityReferenceConstructorAttrNum, ProcessingInstructionConstructorAttrNum, 
        HTMLDocumentConstructorAttrNum, HTMLElementConstructorAttrNum, HTMLAnchorElementConstructorAttrNum, HTMLAppletElementConstructorAttrNum, 
        HTMLAreaElementConstructorAttrNum, HTMLBRElementConstructorAttrNum, HTMLBaseElementConstructorAttrNum, HTMLBaseFontElementConstructorAttrNum, 
        HTMLBlockquoteElementConstructorAttrNum, HTMLBodyElementConstructorAttrNum, HTMLButtonElementConstructorAttrNum, HTMLCanvasElementConstructorAttrNum, 
        HTMLDListElementConstructorAttrNum, HTMLDirectoryElementConstructorAttrNum, HTMLDivElementConstructorAttrNum, HTMLEmbedElementConstructorAttrNum, 
        HTMLFieldSetElementConstructorAttrNum, HTMLFontElementConstructorAttrNum, HTMLFormElementConstructorAttrNum, HTMLFrameElementConstructorAttrNum, 
        HTMLFrameSetElementConstructorAttrNum, HTMLHRElementConstructorAttrNum, HTMLHeadElementConstructorAttrNum, HTMLHeadingElementConstructorAttrNum, 
        HTMLHtmlElementConstructorAttrNum, HTMLIFrameElementConstructorAttrNum, HTMLImageElementConstructorAttrNum, HTMLInputElementConstructorAttrNum, 
        HTMLIsIndexElementConstructorAttrNum, HTMLLIElementConstructorAttrNum, HTMLLabelElementConstructorAttrNum, HTMLLegendElementConstructorAttrNum, 
        HTMLLinkElementConstructorAttrNum, HTMLMapElementConstructorAttrNum, HTMLMarqueeElementConstructorAttrNum, HTMLMenuElementConstructorAttrNum, 
        HTMLMetaElementConstructorAttrNum, HTMLModElementConstructorAttrNum, HTMLOListElementConstructorAttrNum, HTMLObjectElementConstructorAttrNum, 
        HTMLOptGroupElementConstructorAttrNum, HTMLOptionElementConstructorAttrNum, HTMLParagraphElementConstructorAttrNum, HTMLParamElementConstructorAttrNum, 
        HTMLPreElementConstructorAttrNum, HTMLQuoteElementConstructorAttrNum, HTMLScriptElementConstructorAttrNum, HTMLSelectElementConstructorAttrNum, 
        HTMLStyleElementConstructorAttrNum, HTMLTableCaptionElementConstructorAttrNum, HTMLTableCellElementConstructorAttrNum, HTMLTableColElementConstructorAttrNum, 
        HTMLTableElementConstructorAttrNum, HTMLTableRowElementConstructorAttrNum, HTMLTableSectionElementConstructorAttrNum, HTMLTextAreaElementConstructorAttrNum, 
        HTMLTitleElementConstructorAttrNum, HTMLUListElementConstructorAttrNum, EventConstructorAttrNum, MutationEventConstructorAttrNum, 
        NodeFilterConstructorAttrNum, RangeConstructorAttrNum, RangeExceptionConstructorAttrNum, XMLDocumentConstructorAttrNum, 
        DOMParserConstructorAttrNum, XMLSerializerConstructorAttrNum, XPathEvaluatorConstructorAttrNum, XPathResultConstructorAttrNum, 

        // Functions
        GetSelectionFuncNum, FocusFuncNum, BlurFuncNum, CloseFuncNum, 
        PrintFuncNum, StopFuncNum, AlertFuncNum, ConfirmFuncNum, 
        PromptFuncNum, FindFuncNum, GetComputedStyleFuncNum, GetMatchedCSSRulesFuncNum
    };
    DOMWindow* impl() const;
};

DOMWindow* toDOMWindow(KJS::JSValue*);

class JSDOMWindowPrototype : public KJS::JSObject {
public:
    static KJS::JSObject* self();
    virtual const KJS::ClassInfo* classInfo() const { return &info; }
    static const KJS::ClassInfo info;
    bool getOwnPropertySlot(KJS::ExecState*, const KJS::Identifier&, KJS::PropertySlot&);
    JSDOMWindowPrototype() { }
};

class JSDOMWindowPrototypeFunction : public KJS::InternalFunctionImp {
public:
    JSDOMWindowPrototypeFunction(KJS::ExecState* exec, int i, int len, const KJS::Identifier& name)
        : KJS::InternalFunctionImp(static_cast<KJS::FunctionPrototype*>(exec->lexicalInterpreter()->builtinFunctionPrototype()), name)
        , id(i)
    {
        put(exec, exec->propertyNames().length, KJS::jsNumber(len), KJS::DontDelete|KJS::ReadOnly|KJS::DontEnum);
    }
    virtual KJS::JSValue* callAsFunction(KJS::ExecState*, KJS::JSObject*, const KJS::List&);

private:
    int id;
};

} // namespace WebCore

#endif
