/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGPathSegMovetoRel.h"

#include <wtf/GetPtr.h>

#include "SVGPathSegMoveto.h"

using namespace KJS;

namespace WebCore {

/* Hash table */

static const HashEntry JSSVGPathSegMovetoRelTableEntries[] =
{
    { "y", JSSVGPathSegMovetoRel::YAttrNum, DontDelete, 0, 0 },
    { "x", JSSVGPathSegMovetoRel::XAttrNum, DontDelete, 0, 0 }
};

static const HashTable JSSVGPathSegMovetoRelTable = 
{
    2, 2, JSSVGPathSegMovetoRelTableEntries, 2
};

/* Hash table for prototype */

static const HashEntry JSSVGPathSegMovetoRelPrototypeTableEntries[] =
{
    { 0, 0, 0, 0, 0 }
};

static const HashTable JSSVGPathSegMovetoRelPrototypeTable = 
{
    2, 1, JSSVGPathSegMovetoRelPrototypeTableEntries, 1
};

const ClassInfo JSSVGPathSegMovetoRelPrototype::info = { "SVGPathSegMovetoRelPrototype", 0, &JSSVGPathSegMovetoRelPrototypeTable, 0 };

JSObject* JSSVGPathSegMovetoRelPrototype::self(ExecState* exec)
{
    return KJS::cacheGlobalObject<JSSVGPathSegMovetoRelPrototype>(exec, "[[JSSVGPathSegMovetoRel.prototype]]");
}

const ClassInfo JSSVGPathSegMovetoRel::info = { "SVGPathSegMovetoRel", &JSSVGPathSeg::info, &JSSVGPathSegMovetoRelTable, 0 };

JSSVGPathSegMovetoRel::JSSVGPathSegMovetoRel(ExecState* exec, SVGPathSegMovetoRel* impl)
    : JSSVGPathSeg(exec, impl)
{
    setPrototype(JSSVGPathSegMovetoRelPrototype::self(exec));
}

bool JSSVGPathSegMovetoRel::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGPathSegMovetoRel, JSSVGPathSeg>(exec, &JSSVGPathSegMovetoRelTable, this, propertyName, slot);
}

JSValue* JSSVGPathSegMovetoRel::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case XAttrNum: {
        SVGPathSegMovetoRel* imp = static_cast<SVGPathSegMovetoRel*>(impl());

        return jsNumber(imp->x());
    }
    case YAttrNum: {
        SVGPathSegMovetoRel* imp = static_cast<SVGPathSegMovetoRel*>(impl());

        return jsNumber(imp->y());
    }
    }
    return 0;
}

void JSSVGPathSegMovetoRel::put(ExecState* exec, const Identifier& propertyName, JSValue* value, int attr)
{
    lookupPut<JSSVGPathSegMovetoRel, JSSVGPathSeg>(exec, propertyName, value, attr, &JSSVGPathSegMovetoRelTable, this);
}

void JSSVGPathSegMovetoRel::putValueProperty(ExecState* exec, int token, JSValue* value, int /*attr*/)
{
    switch (token) {
    case XAttrNum: {
        SVGPathSegMovetoRel* imp = static_cast<SVGPathSegMovetoRel*>(impl());

        imp->setX(value->toFloat(exec));
        break;
    }
    case YAttrNum: {
        SVGPathSegMovetoRel* imp = static_cast<SVGPathSegMovetoRel*>(impl());

        imp->setY(value->toFloat(exec));
        break;
    }
    }
    SVGPathSegMovetoRel* imp = static_cast<SVGPathSegMovetoRel*>(impl());

    ASSERT(exec && exec->dynamicInterpreter());
    Frame* activeFrame = static_cast<ScriptInterpreter*>(exec->dynamicInterpreter())->frame();
    if (!activeFrame)
        return;

    SVGDocumentExtensions* extensions = (activeFrame->document() ? activeFrame->document()->accessSVGExtensions() : 0);
    if (extensions && extensions->hasGenericContext<SVGPathSeg>(imp)) {
        const SVGElement* context = extensions->genericContext<SVGPathSeg>(imp);
        ASSERT(context);

        context->notifyAttributeChange();
    }

}


}

#endif // ENABLE(SVG)
