/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"


#if ENABLE(SVG)

#include "Document.h"
#include "Frame.h"
#include "SVGDocumentExtensions.h"
#include "SVGElement.h"
#include "SVGAnimatedTemplate.h"
#include "JSSVGZoomEvent.h"

#include <wtf/GetPtr.h>

#include "JSSVGPoint.h"
#include "JSSVGRect.h"
#include "SVGZoomEvent.h"

using namespace KJS;

namespace WebCore {

/* Hash table */

static const HashEntry JSSVGZoomEventTableEntries[] =
{
    { 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0 },
    { "previousScale", JSSVGZoomEvent::PreviousScaleAttrNum, DontDelete|ReadOnly, 0, &JSSVGZoomEventTableEntries[6] },
    { "zoomRectScreen", JSSVGZoomEvent::ZoomRectScreenAttrNum, DontDelete|ReadOnly, 0, &JSSVGZoomEventTableEntries[5] },
    { "newTranslate", JSSVGZoomEvent::NewTranslateAttrNum, DontDelete|ReadOnly, 0, 0 },
    { "previousTranslate", JSSVGZoomEvent::PreviousTranslateAttrNum, DontDelete|ReadOnly, 0, 0 },
    { "newScale", JSSVGZoomEvent::NewScaleAttrNum, DontDelete|ReadOnly, 0, 0 }
};

static const HashTable JSSVGZoomEventTable = 
{
    2, 7, JSSVGZoomEventTableEntries, 5
};

/* Hash table for prototype */

static const HashEntry JSSVGZoomEventPrototypeTableEntries[] =
{
    { 0, 0, 0, 0, 0 }
};

static const HashTable JSSVGZoomEventPrototypeTable = 
{
    2, 1, JSSVGZoomEventPrototypeTableEntries, 1
};

const ClassInfo JSSVGZoomEventPrototype::info = { "SVGZoomEventPrototype", 0, &JSSVGZoomEventPrototypeTable, 0 };

JSObject* JSSVGZoomEventPrototype::self(ExecState* exec)
{
    return KJS::cacheGlobalObject<JSSVGZoomEventPrototype>(exec, "[[JSSVGZoomEvent.prototype]]");
}

const ClassInfo JSSVGZoomEvent::info = { "SVGZoomEvent", &JSUIEvent::info, &JSSVGZoomEventTable, 0 };

JSSVGZoomEvent::JSSVGZoomEvent(ExecState* exec, SVGZoomEvent* impl)
    : JSUIEvent(exec, impl)
{
    setPrototype(JSSVGZoomEventPrototype::self(exec));
}

bool JSSVGZoomEvent::getOwnPropertySlot(ExecState* exec, const Identifier& propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSVGZoomEvent, JSUIEvent>(exec, &JSSVGZoomEventTable, this, propertyName, slot);
}

JSValue* JSSVGZoomEvent::getValueProperty(ExecState* exec, int token) const
{
    switch (token) {
    case ZoomRectScreenAttrNum: {
        SVGZoomEvent* imp = static_cast<SVGZoomEvent*>(impl());

        return toJS(exec, new JSSVGPODTypeWrapper<FloatRect>(imp->zoomRectScreen()));
    }
    case PreviousScaleAttrNum: {
        SVGZoomEvent* imp = static_cast<SVGZoomEvent*>(impl());

        return jsNumber(imp->previousScale());
    }
    case PreviousTranslateAttrNum: {
        SVGZoomEvent* imp = static_cast<SVGZoomEvent*>(impl());

        return toJS(exec, new JSSVGPODTypeWrapper<FloatPoint>(imp->previousTranslate()));
    }
    case NewScaleAttrNum: {
        SVGZoomEvent* imp = static_cast<SVGZoomEvent*>(impl());

        return jsNumber(imp->newScale());
    }
    case NewTranslateAttrNum: {
        SVGZoomEvent* imp = static_cast<SVGZoomEvent*>(impl());

        return toJS(exec, new JSSVGPODTypeWrapper<FloatPoint>(imp->newTranslate()));
    }
    }
    return 0;
}


}

#endif // ENABLE(SVG)
